## fastjet-3.5.1-1.src.tar.gz

=== CMakeLists.txt ===
# List of useful CMake arguments:
#  CMAKE_INSTALL_PREFIX=...     path for the installation
#                               (can be replaced be cmake --install . -- prefix <patth>)
#  FASTJET_ENABLE_DEBUG=ON|OFF  switch debugging info on/off [default:ON]
#  FASTJET_ENABLE_CGAL=ON|OFF   enable CGAL support [default:OFF]
#  FASTJET_ENABLE_PLUGIN_<name>=ON|OFF
#      with <name> in ATLASCONE, CDFCONES, CMSITERATIVECONE, D0RUNICONE, D0RUNIICONE,
#      EECAMBRIDGE, GRIDJET, JADE, NESTEDDEFS, PXCONE, SISCONE, TRACKJET; enable the
#      corresponding FastJet plugin [default:ON except for PxCone]
#
# Note on config file:
#  . include/fastjet/config_auto.h is generated from config-cmake.hh.in
#
# TODO:
# - [ ] incorporate build from cmake-installed version also into CI
# - [ ] have the option of building the testsuite
# - [ ] web page cmake documentation (e.g. quick-start) -> not for 3.5.0, wait until it's been used for a while
# - [x] fastjet-config script
#   - [x] support for --list-plugins
#   - [x] correct list of libraries when --plugins requested
#   - [x] --pythonpath
#   - [x] it is correctly installed
#   - [x] --config option?
# - [x] we are manually setting various compile flags, e.g. -g, -O2, etc.
#       which is not compatible with standard CMake build types
# - [x] checks
#   - [x] that siscone submodule is there 
#   - [x] that siscone/config.h does not exist in the source directory
# - [x] add PxCone support
# - [x] Check the "Release" build
# - [x] add missing examples -> simply moved them into examples/graveyard/
# - [x] make sure all CMakeLists.txt, config-cmake.hh.in, Config.cmake.in files included in tarball
# - [x] add Python support
# - [x] make sure we use shared libs# 
# - [x] specific compilation flags for the D0RunIICone
# - [x] print config summary
# - [x] scripts/set-version.sh should set the version info also in this file
# - [x] ctest to reproduce what make check does
#   - [x] and add it to CI
# - [x] check autotools tarball for cmake in CI
# - [x] CI also for cmake
#   - [x] basic functionality
#   - [x] address comments from M Feickert in !10 on test-all-algs and on python library path
#   - [x] check build from installed system, including fastjet-config and cmake routes
#         (see internal )
# - [x] Add instructions for CMake usage to documentation
#   - [x] for build & installation, and compilation as a text file
#   - [x] similarly in fastjet-doc.tex 
# - [x] make some decisions
#   - [x] what plugins turned on by default -> aim for same list as in autotools + enable-all, enable-allcxx
#   - [x] will we deprecate auto-tools? Schedule for removal when? -> not for 3.5.0
#   - [x] are we happy with Python arrangement (needing swig) -> Yes
# - [x] make sure out-of-source autotools build is (still?) working

cmake_minimum_required(VERSION 3.10.0..4.0.1)
include(CMakePrintHelpers)

# set the project name
project(FastJet VERSION 3.5.1 LANGUAGES CXX)
# set a pre-release version if relevant, e.g. "-beta1"
set(PROJECT_VERSION_PRERELEASE "")
include(GNUInstallDirs)

#----------------------------------------------------------------------
# version information
set(FASTJET_VERSION "${PROJECT_VERSION}${PROJECT_VERSION_PRERELEASE}")

set(FASTJET_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set(FASTJET_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(FASTJET_VERSION_PATCHLEVEL "${PROJECT_VERSION_PATCH}")
set(FASTJET_VERSION_PRERELEASE "${PROJECT_VERSION_PRERELEASE}")
# build a unique version number
if (FASTJET_VERSION_MINOR LESS 10)
  set(FASTJET_VERSION_MINOR_FOR_NUMBER "0${FASTJET_VERSION_MINOR}")
else()
  set(FASTJET_VERSION_MINOR_FOR_NUMBER "${FASTJET_VERSION_MINOR}")
endif()
if (FASTJET_VERSION_PATCHLEVEL LESS 10)
  set(FASTJET_VERSION_PATCHLEVEL_FOR_NUMBER "0${FASTJET_VERSION_PATCHLEVEL}")
else()
  set(FASTJET_VERSION_PATCHLEVEL_FOR_NUMBER "${FASTJET_VERSION_PATCHLEVEL}")
endif()
set(FASTJET_VERSION_NUMBER "${FASTJET_VERSION_MAJOR}${FASTJET_VERSION_MINOR_FOR_NUMBER}${FASTJET_VERSION_PATCHLEVEL_FOR_NUMBER}")

# print out the project name and version
cmake_print_variables(PROJECT_NAME FASTJET_VERSION)

# need this to be able to set the installation prefix in fastjet-config
include(GNUInstallDirs)

#----------------------------------------------------------------------
# basic C++ checks
#----------------------------------------------------------------------

# specify the C++ standard
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)  # <--- GPS 2025-05-22: disable GNU extensions, which cause problems with CGAL on amd64
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})
if (MSVC)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")



# Bail out if config_auto.h exists in the source directory
set (AUTOTOOLS_ERROR_MESSAGE "Found ${PROJECT_SOURCE_DIR}/include/fastjet/config_auto.h in source directory. This would typically have been generated by the autotools (non-CMake) build process. Please run cmake from a clean source directory.")
if (EXISTS "${PROJECT_SOURCE_DIR}/include/fastjet/config_auto.h")
  message(FATAL_ERROR "${AUTOTOOLS_ERROR_MESSAGE}")
endif()

#-------------------------------------------------------------------------
# a series of user-defined options
# If you add something here, check if one also needs to add a corresponding 
# entry in config-cmake.hh.in
#
# CGAL support
option(FASTJET_ENABLE_CGAL  
       "Enable compilation with CGAL (header-only) support, required for most of the NlnN strategies"  
       OFF)

# do we build the examples?
option(FASTJET_BUILD_EXAMPLES "Build the executables in the examples directory [default=ON]" ON)

# thread safety
option(FASTJET_HAVE_THREAD_SAFETY         "Turn on thread safety [default=ON]" ON)
option(FASTJET_HAVE_LIMITED_THREAD_SAFETY "Turn on limited thread safety [default=ON]" ON)
if (FASTJET_HAVE_THREAD_SAFETY)
  set(FASTJET_HAVE_LIMITED_THREAD_SAFETY ON)
endif()


# plugins on/off
option(FASTJET_ENABLE_PLUGIN_CDFCONES         "Enable the CDFCones plugin [default=ON]"           ON)
option(FASTJET_ENABLE_PLUGIN_EECAMBRIDGE      "Enable the EECambridge plugin [default=ON]"        ON)
option(FASTJET_ENABLE_PLUGIN_GRIDJET          "Enable the GridJet plugin [default=ON]"            ON)
option(FASTJET_ENABLE_PLUGIN_JADE             "Enable the Jade plugin [default=ON]"               ON)
option(FASTJET_ENABLE_PLUGIN_NESTEDDEFS       "Enable the NestedDefs plugin [default=ON]"         ON)
option(FASTJET_ENABLE_PLUGIN_SISCONE          "Enable the SISCone plugin [default=ON]"            ON)
option(FASTJET_USE_INSTALLED_SISCONE          "Use an existing installed version of siscone"     OFF)
option(FASTJET_ENABLE_PLUGIN_ATLASCONE        "Enable the ATLASCone plugin [default=OFF]"        OFF)
option(FASTJET_ENABLE_PLUGIN_CMSITERATIVECONE "Enable the CMSIterativeCone plugin [default=OFF]" OFF)
option(FASTJET_ENABLE_PLUGIN_D0RUNICONE       "Enable the D0RunICone plugin [default=OFF]"       OFF)
option(FASTJET_ENABLE_PLUGIN_D0RUNIICONE      "Enable the D0RunIICone plugin [default=OFF]"      OFF)
option(FASTJET_ENABLE_PLUGIN_PXCONE           "Enable the PxCone plugin [default=OFF]"           OFF)
option(FASTJET_ENABLE_PLUGIN_TRACKJET         "Enable the TrackJet plugin [default=OFF]"         OFF)

option(FASTJET_ENABLE_ALLCXXPLUGINS           "Enable all the C++ plugins [default=OFF]"       OFF)
option(FASTJET_ENABLE_ALLPLUGINS              "Enable all the plugins [default=OFF]"           OFF)

if (FASTJET_ENABLE_ALLCXXPLUGINS OR FASTJET_ENABLE_ALLPLUGINS)
  set(FASTJET_ENABLE_PLUGIN_ATLASCONE          ON)
  set(FASTJET_ENABLE_PLUGIN_CDFCONES           ON)
  set(FASTJET_ENABLE_PLUGIN_CMSITERATIVECONE   ON)
  set(FASTJET_ENABLE_PLUGIN_D0RUNICONE         ON)
  set(FASTJET_ENABLE_PLUGIN_D0RUNIICONE        ON)
  set(FASTJET_ENABLE_PLUGIN_EECAMBRIDGE        ON)
  set(FASTJET_ENABLE_PLUGIN_GRIDJET            ON)
  set(FASTJET_ENABLE_PLUGIN_JADE               ON)
  set(FASTJET_ENABLE_PLUGIN_NESTEDDEFS         ON)
  set(FASTJET_ENABLE_PLUGIN_SISCONE            ON)
  set(FASTJET_ENABLE_PLUGIN_TRACKJET           ON)
endif()

if (FASTJET_ENABLE_ALLPLUGINS)
  set(FASTJET_ENABLE_PLUGIN_PXCONE             ON)
endif()

# compile-time debugging info
option(FASTJET_ENABLE_DEBUG "Turn on debug compiler information [default=ON]" ON)

# disable auto-ptr by defaukt
option(FASTJET_HAVE_AUTO_PTR_INTERFACE  "Enable the (deprecated) auto_ptr interface [default=OFF]"  OFF)

# extra warnings
option(FASTJET_ENABLE_EXTRA_WARNINGS  "Enable compile=time extra warnings [default=OFF]"  OFF)

# support for "override" comes automatically as part of C++11 (can be manually disabled)
option(FASTJET_HAVE_OVERRIDE   "Compiler supports override"  ON)

# support for "[[deprecated]]" comes automatically as part of C++14 (can be manually disabled)
option(FASTJET_HAVE_CXX14_DEPRECATED   "Compiler supports [[deprecated]] (C++14)"  ON)

# support for "__attribute__(deprecated)" off by default (use [[deprecated instead]])
option(FASTJET_HAVE_GNUCXX_DEPRECATED "Compiler supports __attribute__(deprecated) (use [[deprecated]] instead"  OFF)

# support for "explicit operator" comes automatically as part of C++11 (can be manually disabled)
option(FASTJET_HAVE_EXPLICIT_FOR_OPERATORS  "Compiler supports explicit operator (C++11)"  ON)

# support for swig-based python bindings
option(FASTJET_ENABLE_PYTHON "Enable building of swig-based fastjet python bindings" OFF)
option(FASTJET_PYINTERFACE_ONLY "Only build the pyinterface model, relying on an external install of fastjet" OFF)

#-------------------------------------------------------------------------
# compile-time options
# add modules to help check compiler support
include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)

if (MSVC)
  message(WARNING "BUILDING FASTJET ON WINDOWS IS NOT SUPPORTED BY THE FASTJET AUTHORS!!!\nDO NOT EXPECT SUPPORT IF THINGS GO WRONG!!!\nWITHIN SCIKIT-BUILD-CORE, CONTACT SCIKIT DEVELOPERS FOR HELP")
  # This flags has been requested in some MRs. While it is included here
  # it has not been tested by the FastJet authors.
  add_compile_definitions(-D_USE_MATH_DEFINES)
endif()

# for every flag in FLAG_LIST, we will check if the compiler supports it
# and if so, add it to the list of compile options
set (FLAG_LIST "")
if (NOT MSVC)
  list(APPEND FLAG_LIST -Wall -Wshadow)
endif()


if (FASTJET_ENABLE_DEBUG)
  if (MSVC)
    list(APPEND FLAG_LIST /Zi)
  else()
    list(APPEND FLAG_LIST -g)
    list(APPEND FLAG_LIST -Woverloaded-virtual)
  endif()
endif()

if (FASTJET_ENABLE_EXTRA_WARNINGS)
  if (MSVC)
    list(APPEND FLAG_LIST /W4)
  else()
    list(APPEND FLAG_LIST -pedantic -Wextra -Wshadow)
  endif()
endif()

foreach(flag  ${FLAG_LIST})
  check_cxx_compiler_flag(${flag} FLAG_SUPPORTED)
  if (FLAG_SUPPORTED)
    message(STATUS "Checking if the compiler supports ${flag}: supported")
    # add_compile_options(...) would potentially apply to all languages, i.e. maybe 
    # also Fortran (PxCone) even though we have tested flags only for C++
    # so we use CMAKE_CXX_FLAGS here.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
    #add_compile_options(${flag})  
  else()
    message(STATUS "Checking if the compiler supports ${flag}: not supported")
  endif()
endforeach()

check_include_file_cxx(execinfo.h FASTJET_HAVE_EXECINFO_H)

if (FASTJET_HAVE_EXECINFO_H)
  try_compile(CXX_ABI_COMPILE_SUCCEEDED ${CMAKE_BINARY_DIR}/compiler-tests ${CMAKE_CURRENT_SOURCE_DIR}/compiler-tests/cxx_abi.cc)
  if (CXX_ABI_COMPILE_SUCCEEDED)
    message("-- C++ ABI support test passed; enabling demangling")
    option(FASTJET_HAVE_DEMANGLING_SUPPORT "Enabling C++ demangling (requires CXX ABI support)" ON)
  else()
    message("-- C++ ABI support test failed; disabling demangling")
    option(FASTJET_HAVE_DEMANGLING_SUPPORT "Enabling C++ demangling (requires CXX ABI support)" OFF)
  endif()
else()
  set(FASTJET_HAVE_DEMANGLING_SUPPORT  OFF)
endif()
