=== include/CMakeLists.txt ===
# just resurse into th eFastJet directory
add_subdirectory(fastjet)
